=== modified file 'bzrlib/tests/http_server.py'
--- bzrlib/tests/http_server.py	2008-06-10 05:55:15 +0000
+++ bzrlib/tests/http_server.py	2008-09-26 15:28:29 +0000
@@ -20,6 +20,7 @@
 import posixpath
 import random
 import re
+import select
 import SimpleHTTPServer
 import socket
 import SocketServer
@@ -418,6 +419,10 @@
         # Allows tests to verify number of GET requests issued
         self.GET_request_nb = 0
 
+    def __repr__(self):
+        return "%s(%s:%s)" % \
+            (self.__class__.__name__, self.host, self.port)
+
     def _get_httpd(self):
         if self._httpd is None:
             rhandler = self.request_handler
@@ -467,6 +472,14 @@
                 httpd.handle_request()
             except socket.timeout:
                 pass
+            except (socket.error, select.error), e:
+               if e[0] == errno.EBADF:
+                   # Starting with python-2.6, handle_request may raise socket
+                   # or select exceptions when the server is shut down (as we
+                   # do).
+                   pass
+               else:
+                   raise
 
     def _get_remote_url(self, path):
         path_parts = path.split(os.path.sep)

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2008-09-26 07:56:08 +0000
+++ bzrlib/tests/test_http.py	2008-09-26 15:28:29 +0000
@@ -1138,7 +1138,7 @@
         url = self.server.get_url()
         t = self._transport(url)
         try:
-            self.assertEqual(t.get('foo').read(), 'proxied contents of foo\n')
+            self.assertEqual('proxied contents of foo\n', t.get('foo').read())
         finally:
             self._restore_env()
 
@@ -1147,7 +1147,7 @@
         url = self.server.get_url()
         t = self._transport(url)
         try:
-            self.assertEqual(t.get('foo').read(), 'contents of foo\n')
+            self.assertEqual('contents of foo\n', t.get('foo').read())
         finally:
             self._restore_env()
 

